SystemOrganization addCategory: #ConfigurationOfICU!

Object subclass: #ConfigurationOfICU
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfICU'!

!ConfigurationOfICU class methodsFor: 'development support' stamp: 'JanVanDeSandt 9/3/2012 21:30'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfICU class methodsFor: 'private' stamp: 'JanVanDeSandt 9/3/2012 21:30'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfICU class methodsFor: 'private' stamp: 'JanVanDeSandt 9/3/2012 21:30'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfICU class methodsFor: 'private' stamp: 'JanVanDeSandt 9/3/2012 21:30'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfICU class methodsFor: 'metacello tool support' stamp: 'JanVanDeSandt 9/3/2012 21:30'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfICU class methodsFor: 'loading' stamp: 'JanVanDeSandt 9/3/2012 21:30'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfICU class methodsFor: 'loading' stamp: 'JanVanDeSandt 9/3/2012 21:30'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfICU class methodsFor: 'loading' stamp: 'JanVanDeSandt 9/3/2012 21:30'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfICU class methodsFor: 'accessing' stamp: 'JanVanDeSandt 9/3/2012 21:30'!
project

	^self new project! !

!ConfigurationOfICU class methodsFor: 'development support' stamp: 'JanVanDeSandt 9/3/2012 21:30'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfICU methodsFor: 'baselines' stamp: 'JanVanDeSandt 9/3/2012 21:51'!
baseline01: spec 
	<version: '0.1-baseline'>
	
	spec for: #common do: [
		spec 
			blessing: #baseline;
			repository: 'http://ss3.gemstone.com/ss/ICU';
				
			project: 'NativeBoost' with: [
				spec
					className: 'ConfigurationOfNativeBoost';
					loads: #( 'Core' );
					repository: 'http://www.squeaksource.com/NativeBoost' ];

			package: 'ICU-Core';

			package: 'ICU-Tests-Core' with: [
				spec requires: #( 'ICU-Core') ];
			
			package: 'ICU-NativeBoost-Core' with: [
				spec requires: #( 'ICU-Core' 'NativeBoost') ];
			
			package: 'ICU-Tests-NativeBoost' with: [
				spec requires: #( 'ICU-Tests-Core' 'ICU-NativeBoost-Core' )].
			
		spec 
			group: 'Core' with: #( 'ICU-Core' 'ICU-NativeBoost-Core' );
			group: 'Tests' with: #( 'ICU-Tests-Core' 'ICU-Tests-NativeBoost' ) ]
! !

!ConfigurationOfICU methodsFor: 'accessing' stamp: 'JanVanDeSandt 9/3/2012 21:30'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfICU methodsFor: 'versions' stamp: 'JanVanDeSandt 9/3/2012 22:06'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline')>

	spec for: #common do: [

		spec blessing: #development.
		spec author: 'Jan van de Sandt'.

		spec 
			project: 'NativeBoost' with: '1.3'.
			
		spec
			package: 'ICU-Core' with: 'ICU-Core-JanVanDeSandt.28';
			package: 'ICU-Tests-Core' with: 'ICU-Tests-Core-JanVanDeSandt.12';
			package: 'ICU-NativeBoost-Core' with: 'ICU-NativeBoost-Core-JanVanDeSandt.17';
			package: 'ICU-Tests-NativeBoost' with: 'ICU-Tests-NativeBoost-JanVanDeSandt.4' ]! !
